//
//  SHAttributedString.m
//  attString
//
//  Created by mac on 16/6/7.
//  Copyright © 2016年 黄. All rights reserved.
//

#import "SHAttributedString.h"
#import <UIKit/UIKit.h>

@implementation SHAttributedString

#define locationKey @"location"
#define lengthKey @"length"


+(CGSize)attributedStringSizeWithAttString:(NSAttributedString*)attString  preinstallSize:(CGSize)size
{

    NSRange range = NSMakeRange(0, attString.length);
    NSDictionary *dict =  [attString attributesAtIndex:0 effectiveRange:&range];

    CGSize stringSize  = [attString.string boundingRectWithSize:size options:NSStringDrawingUsesLineFragmentOrigin | NSStringDrawingUsesFontLeading attributes:dict context:nil].size;

    return stringSize;
}


+(NSAttributedString*)attributedStringWithString:(NSString*)string andUrlStringName:(NSString*)urlName line:(BOOL)isLine
{
    if (string==nil || [string isEqualToString:@""]) return nil;
    
    NSArray *rangeArr = [self urlRangeArrWithString:string];
    
    NSString *urlStr;
    NSMutableAttributedString *attStr;
    
    
    if (rangeArr)
    {
        NSMutableArray *urlArr = [NSMutableArray array];
        
        for (NSDictionary *dict in rangeArr)
        {
            int locationI = [dict[locationKey]intValue];
            int lengthI = (int)[dict[lengthKey]integerValue];
            NSRange range = NSMakeRange(locationI, lengthI);
            
            urlStr = [string substringWithRange:range];
            [urlArr addObject:urlArr];
            
        }
        
        
        
        //网页标识
        if (urlName==nil || [urlName isEqualToString:@""])
        {
            attStr = [[NSMutableAttributedString alloc]initWithString:string];
            
            for (NSDictionary *dict in rangeArr)
            {
                int locationI = [dict[locationKey]intValue];
                int lengthI = (int)[dict[lengthKey]integerValue];
                NSRange range = NSMakeRange(locationI, lengthI);
                
                urlStr = [string substringWithRange:range];
                
                attStr = [[NSMutableAttributedString alloc]initWithAttributedString:attStr];
                
                NSDictionary *attrDict;
                if (isLine)
                {
                    attrDict = @{ NSLinkAttributeName: [NSURL URLWithString: urlStr],NSUnderlineStyleAttributeName:@(NSUnderlineStyleSingle)};
                }else
                {
                    attrDict = @{ NSLinkAttributeName: [NSURL URLWithString: urlStr]};
                }

                [attStr addAttributes:attrDict range:range];
                
            }
            
        }else
        {
            
            NSMutableArray *attrDict_Arr = [NSMutableArray array];
            NSMutableArray *urlRange_Arr = [NSMutableArray array];
            NSMutableArray *url_Arr = [NSMutableArray array];
            for (NSDictionary *dict in rangeArr)
            {
                int locationI = [dict[locationKey]intValue];
                int lengthI = (int)[dict[lengthKey]integerValue];
                NSRange range = NSMakeRange(locationI, lengthI);
                
                urlStr = [string substringWithRange:range];
                [url_Arr addObject:urlStr];

            }
            
            
            NSString *sub_str = string;
            NSInteger index = 0;
            
            for (int i = 0; i < url_Arr.count; ++i)
            {
                NSString *urlStr = url_Arr[i];
                sub_str = [sub_str stringByReplacingOccurrencesOfString:urlStr withString:urlName];
            
                NSRange range = [sub_str rangeOfString:urlName];
                sub_str = [sub_str substringFromIndex:(range.location+range.length)];
                
                 NSRange urlRange = NSMakeRange(range.location + index, urlName.length);
                index = (range.length + range.location +index);
   
                NSDictionary *ranDic = @{locationKey:@(urlRange.location),lengthKey:@(urlRange.length)};
                [urlRange_Arr addObject:ranDic];
                
                NSDictionary *attrDict1;
                if (isLine)
                {
                    attrDict1 = @{ NSLinkAttributeName: [NSURL URLWithString: urlStr],NSUnderlineStyleAttributeName:@(NSUnderlineStyleSingle)};
                }else
                {
                    attrDict1 = @{ NSLinkAttributeName: [NSURL URLWithString: urlStr]};
                }
                
                [attrDict_Arr addObject:attrDict1];
                
                string = [string stringByReplacingOccurrencesOfString:urlStr withString:urlName];
            }
            
            attStr = [[NSMutableAttributedString alloc]initWithString:string];
            
            for (int i = 0; i < urlRange_Arr.count; ++i)
            {
                                
                NSDictionary *dict = urlRange_Arr[i];
                int locationI = [dict[locationKey]intValue];
                int lengthI = (int)[dict[lengthKey]integerValue];
                NSRange range = NSMakeRange(locationI, lengthI);

               NSDictionary *attrDict = attrDict_Arr[i];
                
                [attStr addAttributes:attrDict range:range];
            }
            
        }
                
    }
    
    return attStr.copy;
}




+(NSAttributedString*)attributedStringWithAttString:(NSAttributedString*)attString andUrlStringName:(NSString*)urlName urlStr:(NSString*)urlStr line:(BOOL)isLine
{
    NSRange range = [attString.string rangeOfString:urlStr];
 
    if (range.length==0) return attString;
    
    
    NSMutableAttributedString *att_str = [[NSMutableAttributedString alloc]initWithAttributedString:attString];
    

    NSInteger  index = 0;
    [att_str  replaceCharactersInRange:range withString:urlName];
    NSString *string = att_str.string;
    while (true)
    {
        NSRange tmpRange = [string rangeOfString:urlName];
        if (tmpRange.length==0) break;
        
        
        NSRange UrlNameRange = NSMakeRange(index + tmpRange.location, urlName.length);
        index = tmpRange.location +tmpRange.length+index;
        NSDictionary *attrDict;
        if (isLine)
        {
            attrDict = @{ NSLinkAttributeName: [NSURL URLWithString: urlStr],NSUnderlineStyleAttributeName:@(NSUnderlineStyleSingle)};
        }else
        {
            attrDict = @{ NSLinkAttributeName: [NSURL URLWithString: urlStr]};
        }
        
        [att_str addAttributes:attrDict range:UrlNameRange];
        
        range = [att_str.string rangeOfString:urlStr];
        
        if (range.length!=0)
        {[att_str  replaceCharactersInRange:range withString:urlName];};
        
        
        string = att_str.string;
        string = [string substringFromIndex:index];
    }
    


    
        return att_str.copy;
}



//匹配字符里的url 返回range数组
+(NSArray*)urlRangeArrWithString:(NSString*)string
{
    NSString *regulaStr = @"((http[s]{0,1}|ftp)://[a-zA-Z0-9\\.\\-]+\\.([a-zA-Z]{2,4})(:\\d+)?(/[a-zA-Z0-9\\.\\-~!@#$%^&*+?:_/=<>]*)?)|(www.[a-zA-Z0-9\\.\\-]+\\.([a-zA-Z]{2,4})(:\\d+)?(/[a-zA-Z0-9\\.\\-~!@#$%^&*+?:_/=<>]*)?)";
    
    //创建正则表达式
    NSError *error = nil;
    NSRegularExpression *rge = [NSRegularExpression regularExpressionWithPattern:regulaStr options:0 error:&error];

    if (error){ return nil; }
    
    
    NSMutableArray *rangeArr = [NSMutableArray array];
    
    
    while (true)
    {
        NSInteger index;
        //匹配字符
        NSTextCheckingResult *rs = [rge firstMatchInString:string options:0 range:NSMakeRange(0, string.length)];
        
        if (rs)
        {
            NSDictionary *ranDic = @{locationKey:@(rs.range.location + index),lengthKey:@(rs.range.length)};
            [rangeArr addObject:ranDic];
            
            index = (rs.range.length + rs.range.location +index);
            string = [string substringFromIndex:(rs.range.length + rs.range.location)];
        }else
        {
            break;
        }
    }
    

    return rangeArr.copy;
}



//匹配字符里的url 返回url数组
+(NSArray*)urlArrWithString:(NSString*)string
{
    NSString *regulaStr = @"((http[s]{0,1}|ftp)://[a-zA-Z0-9\\.\\-]+\\.([a-zA-Z]{2,4})(:\\d+)?(/[a-zA-Z0-9\\.\\-~!@#$%^&*+?:_/=<>]*)?)|(www.[a-zA-Z0-9\\.\\-]+\\.([a-zA-Z]{2,4})(:\\d+)?(/[a-zA-Z0-9\\.\\-~!@#$%^&*+?:_/=<>]*)?)";
    
    //创建正则表达式
    NSError *error = nil;
    NSRegularExpression *rge = [NSRegularExpression regularExpressionWithPattern:regulaStr options:0 error:&error];
    
    if (error){ return nil; }
    
    
    NSMutableArray *rangeArr = [NSMutableArray array];
    
    
    while (true)
    {
        //匹配字符
        NSTextCheckingResult *rs = [rge firstMatchInString:string options:0 range:NSMakeRange(0, string.length)];
        
        if (rs)
        {
            NSString *urlStr = [string substringWithRange:rs.range];
            [rangeArr addObject:urlStr];
            string = [string substringFromIndex:(rs.range.length + rs.range.location)];
        }else
        {
            break;
        }
    }
    
    
    
    return rangeArr.copy;
}


+(NSAttributedString*)attributedStringWithAttributedString:(NSAttributedString*)attributedString andColor:(UIColor *)stringColor  font:(UIFont*)font range:(NSRange)range
{
    NSMutableAttributedString *attstr = [[NSMutableAttributedString alloc]initWithAttributedString:attributedString];
    
    NSDictionary *dict;
    if (stringColor&&!font)
    {
        dict = @{NSForegroundColorAttributeName:stringColor};
    }
    
    if (font &&!stringColor)
    {
        dict = @{NSFontAttributeName:font};
    }
    
    if (stringColor && font)
    {
        //设置换行样式
        NSMutableParagraphStyle *paraStyle02 = [[NSMutableParagraphStyle alloc] init];
        //        NSLineBreakByWordWrapping = 0, //自动换行，单词切断
        //        NSLineBreakByCharWrapping,     //自动换行，字母切断
        paraStyle02.lineBreakMode = NSLineBreakByCharWrapping;
        
        dict = @{NSForegroundColorAttributeName:stringColor,NSFontAttributeName:font,NSParagraphStyleAttributeName:paraStyle02};
    }
    
    if (range.length==0)
    {
        range = NSMakeRange(0, attstr.length);
    }
    [attstr addAttributes:dict range:range];
    
    return attstr.copy;
}


+(NSAttributedString*)attributedStringWithAttributedString:(NSAttributedString*)attributedString insertImage:(UIImage*)image atIndex:(NSInteger)index
{
     NSMutableAttributedString *attstr = [[NSMutableAttributedString alloc]initWithAttributedString:attributedString];
    
    NSTextAttachment *textAttachment = [[NSTextAttachment alloc]init];
    textAttachment.image = image;

    textAttachment.bounds = CGRectMake(0, -attstr.size.height/5, attstr.size.height, attstr.size.height);
    
    NSAttributedString *att_str = [NSAttributedString attributedStringWithAttachment:textAttachment];

    [attstr insertAttributedString:att_str atIndex:index];
    
    return attstr.copy;
}


@end
